#!/usr/bin/env python3
#coding: utf-8

from math import log, sqrt
import sys
import csv

# compute cos(P||Q)

# read counts from files
def readfile(filename):
    result = dict()
    fh = open(filename)
    tsv = csv.reader(fh, delimiter='\t')
    for line in tsv:
        result[tuple(line[1:])] = int(line[0])
    return result

# the source language which we use to train the parser (Q)
source_counts = readfile(sys.argv[1])

# the language we want to parse (P)
target_counts = readfile(sys.argv[2])

cos = 0

# numerator -- sum of scalar products
for bigram in target_counts:
    if bigram in source_counts:
        cos += target_counts[bigram] * source_counts[bigram]

# denominator -- product of vector lengths
source_counts_length = sqrt(sum([x*x for x in source_counts.values()]))
target_counts_length = sqrt(sum([x*x for x in target_counts.values()]))

cos /= source_counts_length * target_counts_length

print(cos)

