#!/usr/bin/env perl
use strict;
use warnings;
use utf8;
use autodie;

sub say {
    my $line = shift;
    print "$line\n";
}

sub tsvsay {
    my $line = join "\t", @_;
    print "$line\n";
}

binmode STDIN, ':utf8';
binmode STDOUT, ':utf8';
binmode STDERR, ':utf8';

my $line;
while($line = <>) {
    chomp $line;
    my ($lang, %kl) = split /\t/, $line;
    my %invkl4 = ();
    foreach my $tag (keys %kl) {
        $invkl4{$tag} = ($kl{$tag} == 0 ? 0 : $kl{$tag}**-4);
    }
    tsvsay($lang, %invkl4);
}
