#!/bin/bash
# test language
l=$1
shift
# config (no file extension, no lang specifier)
c=$1
shift
# models
langs="ar bg ca el es et fa fi hi hu it ja"
m=`for lang in $langs; do echo -n "${lang}_${c}.model $1 "; shift; done`

echo "Going to test the unlabelled parser."
echo "Train languages: $langs"
echo "Test language: $l"
echo "Config: $c.config"
echo "Test file: $l/test.conll"
echo "Model files with weights: $m"

mkdir -p $HOME/models/
cd $HOME/models/
ln -s $HOME/projection_parsing/$c.config
$HOME/mst_perl/scripts/test_conll_treecomb_weighted.pl /a/LRC_TMP/hamledt/rur_projection_parsing/$l/test.conll $c.config $m

